## v4 2

=== OSMesa/Makefile ===
POSTFIX = -osmesa
CC = g++
RM = rm -f
RMDIR = rm -rf
MAKEDEPEND = gcc -MM

LDLIBDIRS = -L../../TCFoundation -L../../TRE -L../../LDLoader -L../../LDLib -L../../LDExporter
LIBDIRS = $(LDLIBDIRS) -L/usr/X11R6/lib
LIBS = -lLDraw$(POSTFIX) -lTRE$(POSTFIX) -lLDLoader$(POSTFIX) -lTCFoundation$(POSTFIX) -lLDExporter$(POSTFIX) -lgl2ps -lpng -lz -lOSMesa -lGLU -lGL -ljpeg -ltinyxml -L ../../lib
STATIC =
ARCH32 =
LDLIBS = ../TCFoundation/libTCFoundation$(POSTFIX).a ../LDLoader/libLDLoader$(POSTFIX).a ../TRE/libTRE$(POSTFIX).a ../LDLib/libLDraw$(POSTFIX).a ../LDExporter/libLDExporter$(POSTFIX).a
MAKEMODE = POSTFIX=-osmesa USE_BOOST=NO

CFLAGS = -o $(OBJDIR)/$*.o $(TESTING) -Wall -D_GNU_SOURCE -O3

CSRCS = $(wildcard *.c)
CCSRCS =  ldview.cpp

BASEDIR=$(realpath $(shell if test -d 3rdParty ; then pwd ; else if test -d ../3rdParty ; then echo .. ;fi;fi))

ifeq ($(shell uname -s), Darwin)
CFLAGS += -arch i386 -arch ppc
AR = libtool -static  -o
else
AR = ar rcs
endif

INCLUDE = -I.. -I../include

ifeq ($(shell uname -m), x86_64)
ifeq ($(LDVDEV32), YES)
CFLAGS += -m32
ARCH32 = -m32
LIBDIRS += -L/usr/lib32
LIBS += -l3ds
else
LIBS += -l3ds-64
endif
else
LIBS += -l3ds
endif

# slurm is media.peeron.com
ifeq ($(shell hostname), slurm)
INCLUDE += -I../../Mesa-7.0.2/include
LIBDIRS += -L../../../Mesa-7.0.2/lib
#STATIC = -static
endif

ifeq ($(shell hostname | cut -d. -f2-), pair.com)
# CFLAGS += -DNO_WSTRING -DNO_WCSTOUL -DTC_NO_UNICODE -DNO_WPRINTF
INCLUDE += -I../../Mesa-7.11/include -I/usr/local/include
LIBDIRS += -L../../../Mesa-7.11/lib -L/usr/local/lib/pth -L/usr/local/lib
LIBS += -lpth
STATIC = -static
endif

CFLAGS += -D_OSMESA -D_NO_BOOST

ifeq ($(shell if [ -d /usr/include/qt3 ]; then echo OK; fi),OK)
INCLUDE += -I/usr/include/qt3
endif

OBJDIR = .obj$(POSTFIX)

VPATH = $(OBJDIR)

SRCS = $(CSRCS) $(CCSRCS)
COBJS = $(CSRCS:.c=.o)
CCOBJS = $(CCSRCS:.cpp=.o)
OBJS = $(COBJS) $(CCOBJS)

.SUFFIXES:

.SUFFIXES:  .cpp .o .c

.cpp.o:
	$(CC) $(CFLAGS) $(INCLUDE) $(CFLAGSLOC) -c $<

.c.o:
	$(CC) $(CFLAGS) $(INCLUDE) $(CFLAGSLOC) -c $<

all:    $(OBJDIR) ldview

../TCFoundation/libTCFoundation$(POSTFIX).a:
	cd ../TCFoundation; $(MAKE) $(MAKEMODE)

../LDLoader/libLDLoader$(POSTFIX).a:
	cd ../LDLoader; $(MAKE) $(MAKEMODE)

../TRE/libTRE$(POSTFIX).a:
	cd ../TRE; $(MAKE) $(MAKEMODE)

../LDLib/libLDraw$(POSTFIX).a:
	cd ../LDLib; $(MAKE) $(MAKEMODE)

../LDExporter/libLDExporter$(POSTFIX).a:
	cd ../LDExporter; $(MAKE) $(MAKEMODE)

ifneq ($(shell if test -f /usr/include/tinyxml.h ; then echo OK ; fi),OK)
LIBS +=-L$(BASEDIR)/3rdParty/tinyxml
ldview:    $(BASEDIR)/3rdParty/tinyxml/libtinyxml.a
$(BASEDIR)/3rdParty/tinyxml/libtinyxml.a: $(BASEDIR)/3rdParty/tinyxml/*.cpp $(BASEDIR)/3rdParty/tinyxml/*.h
	cd $(BASEDIR)/3rdParty/tinyxml/ ; make -f Makefile.pbartfai
tinyxmlclean:
	cd ../3rdParty/tinyxml ; make -f Makefile.pbartfai clean
clean: tinyxmlclean
endif

ifneq ($(shell if test -f /usr/include/gl2ps.h ; then echo OK ; fi),OK)
LIBS +=-L$(BASEDIR)/gl2ps
ldview: $(BASEDIR)/gl2ps/libgl2ps.a
$(BASEDIR)/gl2ps/libgl2ps.a: $(BASEDIR)/gl2ps/*.c $(BASEDIR)/gl2ps/*.h
	cd $(BASEDIR)/gl2ps ; make

gl2psclean:
	cd ../gl2ps ; make clean
clean: gl2psclean
endif

$(OBJDIR):
	if [ ! -d $(OBJDIR) ]; then \
		mkdir $(OBJDIR);                \
	fi

depend:
	$(RM) .depend
	$(MAKEDEPEND) $(INCLUDE) $(SRCS) > .depend

Headerize: Headerize.o $(LDLIBS)
	cd $(OBJDIR); $(CC) $(STATIC) $(ARCH32) $(TESTING) -o ../Headerize Headerize.o $(LIBDIRS) -L../TCFoundation -lTCFoundation-osmesa -ljpeg -lpng -lz

LDViewMessages.h: Headerize ../LDViewMessages.ini
	./Headerize ../LDViewMessages.ini

StudLogo.h: Headerize ../Textures/StudLogo.png
	./Headerize ../Textures/StudLogo.png

ldview.o: StudLogo.h LDViewMessages.h

ldview: $(LDLIBS) $(OBJS)
	cd $(OBJDIR); $(CC) $(STATIC) $(ARCH32) $(TESTING) -o ../ldview $(OBJS) $(LIBDIRS) $(LIBS)

webgrabber:	$(OBJS)
			$(CC) -o webgrabber $(OBJS) $(LIBDIRS) $(LIBS)

clean: MAKEMODE = clean POSTFIX=-osmesa
clean:
	cd ../TRE ;          $(MAKE) $(MAKEMODE)
	cd ../LDLib ;        $(MAKE) $(MAKEMODE)
	cd ../TCFoundation ; $(MAKE) $(MAKEMODE)
	cd ../LDLoader ;     $(MAKE) $(MAKEMODE)
	cd ../LDExporter ;   $(MAKE) $(MAKEMODE)
	if [ -d $(OBJDIR) ] ; then	\
		cd $(OBJDIR);			\
		$(RM) $(OBJS);			\
	fi
	$(RMDIR) $(OBJDIR)
	$(RM) ldview core Headerize StudLogo.h

debug: CFLAGSLOC = -g -DUNZIP_CMD
debug: MAKEMODE = debug POSTFIX=-osmesa
debug: all

test:
	if [ ! -f ~/.ldviewrc ] ; then      \
		cp ldviewrc.sample ~/.ldviewrc; \
	fi
	./ldview ../8464.mpd -SaveSnapshot=/tmp/8464.png \
	-SaveWidth=128 -SaveHeight=128 -ShowErrors=0 -SaveActualSize=0
	file /tmp/8464.png

=== QT/debian/changelog ===
ldview (4.2) stable; urgency=low

  * Release 4.2

 -- Peter Bartfai <pbartfai@stardust.hu>  Thu, 26 Jun 2014 11:30:03 +0200

=== QT/debian/control ===
Source: ldview
Section: graphics
Maintainer: Peter Bartfai <pbartfai@stardust.hu>
Priority: optional
Build-Depends: debhelper (>= 4.1.6), libqt4-dev, cmake, kdelibs5-dev, libgl1-mesa-dev, libboost-dev, libpng12-dev
Homepage: http://ldview.sourceforge.net/
Standards-Version: 3.9.4

Package: ldview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Real-time 3D viewer for displaying LDraw models
 LDView is a real-time 3D viewer for displaying LDraw models using
 hardware-accelerated 3D graphics. LDView is capable of reading LDraw DAT,
 LDR and MPD files as well as parse subassemblies for the latter,
 using the multipart tools menu. You can view and rotate the model around
 to any angle using the mouse or keyboard. LDView was written using OpenGL:
 it should provide accelerated rendering on any video card capable of
 full OpenGL 3D acceleration (so-called 'mini-drivers' are not likely to work).
 It should also work on other video cards using OpenGL software rendering,
 albeit at a much slower speed. A  fast computer or a dedicated video card
 with T&L support (Transform & Lighting) is strongly recommended
 for displaying complex models. For information on LDraw,
 please visit www.ldraw.org, the centralized LDraw resources site.

=== QT/debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
# export DH_COMPAT=7

CFLAGS = -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CFLAGS += -O0
else
CFLAGS += -O2
endif

NOBOOST = `if [ -f /usr/src/packages/BUILD/QT/LDView.pro ] ; then echo 'DEFINES+=_NO_BOOST' ; fi`
TESTING := $(shell if [ ! -f /usr/include/gl2ps.h ] ; then echo -I ../gl2ps -L ../gl2ps ; fi; if [ ! -f /usr/include/tinyxml.h ] ; then echo -I ../3rdParty/tinyxml ; fi)
DEST=$(shell if [ -f /usr/src/packages/BUILD/QT/LDView.pro ] ; then echo /usr/src/packages/BUILD/debian/ldview ; else echo debian/ldview ; fi )
export Q_LDFLAGS="-Wl,-z,relro"

build-arch: build
build-indep: build
build: build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	if [ -f LDView.pro ] ; then cd .. ; fi ; \
	cd OSMesa ;                              \
	export TESTING="$(TESTING)" ;            \
	make all ;                               \
	cd ../QT ;                               \
	if [ `uname -m` = "x86_64" ] ; then      \
		qmake-qt4 -config release        \
		 -spec linux-g++-64 $(NOBOOST) ; \
	else                                     \
		qmake-qt4 -config release        \
		 -spec linux-g++-32 $(NOBOOST) ; \
	fi ;                                     \
	lrelease-qt4 LDView.pro ;                \
	make all ;                               \
	cd kde ; mkdir -p build ; cd build ;     \
	cmake -DCMAKE_INSTALL_PREFIX=`kde4-config --prefix` .. ; \
	make all
	# --- end custom part for compiling

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	# Add here commands to clean up after the build process.
	if [ -f LDView.pro ] ; then cd .. ; fi ; \
	cd 3rdParty/tinyxml ; make -f Makefile.pbartfai clean || true
	if [ -f LDView.pro ] ; then cd .. ; fi ; \
	cd QT ; qmake-qt4 ; make clean || true ; cd .. ;\
	cd OSMesa ; make clean || true ; cd .. ; \
	cd QT/kde ; if [ -d build ]; then rm -rf build ; fi
	# --- end custom part for cleaning up
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package
	# The DESTDIR Has To Be Exactly  /usr/src/packages/BUILD/debian/<nameOfPackage>
	if [ -f LDView.pro ] ; then cd .. ; fi ; \
	cd QT ; make INSTALL_ROOT=$(DEST) install              ;\
	rm -f $(DEST)/usr/share/ldview/license.txt             ;\
	cp -f ../OSMesa/ldview $(DEST)/usr/bin/                ;\
	mkdir -p $(DEST)/usr/share/mime-info/                  ;\
	mkdir -p $(DEST)/usr/share/mime/packages/              ;\
	mkdir -p $(DEST)/usr/share/application-registry/       ;\
	mkdir -p $(DEST)/usr/share/applications/               ;\
	mkdir -p $(DEST)/usr/share/thumbnailers/               ;\
	mkdir -p $(DEST)/usr/share/pixmaps/                    ;\
	mkdir -p $(DEST)/usr/share/icons/gnome/32x32/mimetypes ;\
	mkdir -p $(DEST)/usr/share/gconf/schemas               ;\
	mkdir -p $(DEST)/usr/share/man/man1                    ;\
	install -m 644 desktop/ldraw.mime                       \
		$(DEST)/usr/share/mime-info/ldraw.mime         ;\
	install -m 644 desktop/ldraw.xml                        \
		$(DEST)/usr/share/mime/packages/ldraw.xml      ;\
	install -m 644 desktop/ldraw.keys                       \
		$(DEST)/usr/share/mime-info/ldraw.keys         ;\
	install -m 644 desktop/ldview.applications              \
		$(DEST)/usr/share/application-registry/ldview.applications ;\
	install -m 644 desktop/ldview.desktop                   \
		$(DEST)/usr/share/applications/ldview.desktop  ;\
	install -m 644 desktop/ldview.thumbnailer               \
		$(DEST)/usr/share/thumbnailers/ldview.thumbnailer;\
	install -m 755 desktop/ldraw-thumbnailer                \
		$(DEST)/usr/bin/ldraw-thumbnailer              ;\
	install -m 644 images/LDViewIcon.png                    \
		$(DEST)/usr/share/pixmaps/gnome-ldraw.png      ;\
	install -m 644 images/LDViewIcon.png                    \
		$(DEST)/usr/share/icons/gnome/32x32/mimetypes/gnome-mime-application-x-ldraw.png ;\
	install -m 644 images/LDViewIcon.png                    \
		$(DEST)/usr/share/icons/gnome/32x32/mimetypes/gnome-mime-application-x-multipart-ldraw.png ;\
	install -m 644 desktop/ldraw.schemas                    \
		$(DEST)/usr/share/gconf/schemas/ldraw.schemas  ;\
	mkdir -p $(DEST)/usr/share/kde4/services               ;\
	install -m 644 kde/ldviewthumbnailcreator.desktop       \
		$(DEST)/usr/share/kde4/services/ldviewthumbnailcreator.desktop ;\
	install -m 644 LDView.1                                 \
		$(DEST)/usr/share/man/man1/LDView.1            ;\
	gzip -f -9 $(DEST)/usr/share/man/man1/LDView.1         ;\
	install -m 644 desktop/ldraw-thumbnailer.1              \
		$(DEST)/usr/share/man/man1/ldraw-thumbnailer.1 ;\
	gzip -f -9 $(DEST)/usr/share/man/man1/ldraw-thumbnailer.1;\
	install -m 644 ../OSMesa/ldview.1                       \
		$(DEST)/usr/share/man/man1/ldview.1            ;\
	gzip -f -9 $(DEST)/usr/share/man/man1/ldview.1
	# --- end custom part for installing

# Build architecture-independent files here.
binary-indep: build install
	# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
	dh_gconf
#	dh_undocumented
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
